% do all the steps for the round besides historical forecasts

function allround(self)

  % get round options
  opt = self.get_round_options();

  % observed data
  self.observeddata();
  
  % read model(s)
  self.readmodel();
  
  % analyze model
  self.analyzemodel();
  
  % filter history
  hist_scenarios = opt.round_scenarios;
  if isfield(opt, 'hist_use')
    hist_scenarios = hist_scenarios + struct2cell(opt.hist_use) ...
        - fieldnames(opt.hist_use);
  end
  for i = 1:length(hist_scenarios)
    self.filterhistory(hist_scenarios{i});
  end
  
  % forecasts
  self.forecast(opt.round_scenarios{1});
  for i = 2:length(opt.round_scenarios)
    self.forecast(opt.round_scenarios{i}, opt.round_scenarios{1});
  end

end
