% expand islog information from the model using the FPAS mnemonics for the
% variables being introduced by cmop.postprocess_database()
function islog = expand_islog(islog, ratesmat)

  % exchange rate
  islog = dbbatch(islog, 'S$1', 'true', 'nameFilter','L_S(.*)');
  islog = dbbatch(islog, 'OBS_S$1', 'true', 'nameFilter','OBS_L_S(.*)');
 
  % DOTA
  islog = dbbatch(islog, 'DOTA_$1', 'false', 'nameFilter','DLA_(.*)');
  islog = dbbatch(islog, 'OBS_DOTA_$1','false', 'nameFilter','OBS_DLA_(.*)');
 
  % DOT4
  islog = dbbatch(islog, 'DOT4_$1', 'false', 'nameFilter','D4L_(.*)');
  islog = dbbatch(islog, 'OBS_DOT4_$1', 'false', 'nameFilter','OBS_D4L_(.*)');
 
  % interest rates
  rsnames = fieldnames(ratesmat);
  islog = dbbatch(islog, 'AC_$0', 'false', 'nameList', rsnames);
  islog = dbbatch(islog, 'NC_$0', 'false', 'nameList', rsnames);
  islog = dbbatch(islog, 'OBS_AC_$0', 'false', 'nameList', rsnames);
  islog = dbbatch(islog, 'OBS_NC_$0', 'false', 'nameList', rsnames);
end
