function write_fcast_report_xml(outfile,rd,sc,opt,d,m)  
  
  indent = '    ';
  rng = opt.report_plot_range;
  
  % open file and start writing
  fid = fopen(outfile, 'w');
  
  % header
  fprintf(fid,'<report>\n');
  
  % name
  fprintf(fid,'%s<reportname>%s</reportname>\n',indent,sc);
  fprintf(fid,'%s<reportdesc></reportdesc>\n',indent);
  
  % range
  fprintf(fid,'%s<rangestart>%s</rangestart>\n',indent,dat2char(rng(1)));
  fprintf(fid,'%s<rangeend>%s</rangeend>\n',indent,dat2char(rng(end)));
  
  % variable descriptions
  vardesc = get(m, 'comments');
  
  % pages
  for i = 1 : length(rd)
     p = rd{i};
     if isfield(p,'series')
        write_page(fid,indent,p,d,vardesc);
     end
  end
  
  % footer
  fprintf(fid,'</report>\n');
  fclose(fid);  
end

function write_page(fid,indent,p,d,vardesc)
  indent2 = [indent,indent];
  indent3 = [indent2,indent];
  fprintf(fid,'%s<page>\n',indent);
  fprintf(fid,'%s<pagename>%s</pagename>\n',indent2,p.title);
  fprintf(fid,'%s<pagedesc>%s</pagedesc>\n',indent2,p.title);
  num_charts = numel(p.series);
  if num_charts == 1, num_col = 1; end;
  if num_charts > 1 && num_charts < 5, num_col = 2; end;
  if num_charts > 4 && num_charts < 10, num_col = 3; end;
  if num_charts > 10, num_col = 4; end;
  fprintf(fid,'%s<figure columns="%i" rows="auto">\n',indent2,num_col);
  fprintf(fid,'%s<figurename>Figure from %s</figurename>\n',indent3,p.title);
  for i = 1 : numel(p.series)
      % check if variable has been transformed
      varname = p.series{i};
      if strfind(varname,'NC_')==1, varname = regexprep(varname,'NC_',''); end;
      if strfind(varname,'DOT4_')==1, varname = regexprep(varname,'DOT4_','D4L_'); end;
      if strfind(varname,'DOTA_')==1, varname = regexprep(varname,'DOTA_','DLA_'); end;
      write_chart(fid,indent,varname,d,vardesc.(varname));
  end
  fprintf(fid,'%s</figure>\n',indent2);  
  fprintf(fid,'%s</page>\n',indent);
end

function write_chart(fid,indent,var,d,vardescstr)
  indent2 = [indent,indent];
  indent3 = [indent2,indent];
  indent4 = [indent3,indent];
  indent5 = [indent4,indent];
  lineopt = 'type="line" color="blue" lineStyle="-" axis="left" unitsInLegend="true"';
  fprintf(fid,'%s<chart>\n',indent3);
  [varname,units] = strtok(vardescstr,'(');
  varname = char(varname);
  units = char(regexprep(units,{'(',')'},''));
  fprintf(fid,'%s<chartname>%s</chartname>\n',indent4,varname(1:end-1));
  fprintf(fid,'%s<series name="%s" %s>\n',indent4,var,lineopt);
  fprintf(fid,'%s<legendentry/>\n',indent5);
  fprintf(fid,'%s<units>%s</units>\n',indent5,units);
  fprintf(fid,'%s</series>\n',indent4);
  fprintf(fid,'%s</chart>\n',indent3);
end