function write_scenario_xml(outfile,sc,r,dtunes)  
  
  % open file and start writing
  fid = fopen(outfile, 'w');
  fprintf(fid, '<scenario isAbsolute="true">\n');
  
  % scenario name
  fprintf(fid, '	<scenarioname>%s</scenarioname>\n',sc);
  fprintf(fid, '    <scenariodesc>%s</scenariodesc>\n',sc);
  
  % scenario dates
  fprintf(fid, '    <startdate>%s</startdate>\n',dat2char(r.range(1)));
  fprintf(fid, '    <enddate>%s</enddate>\n',dat2char(r.range(end)));
  
  % tunes
  fprintf(fid, '    <tunes>\n');
  
  % anticipated hard tunes    
  ant_exo_list = fieldnames(r.anticipated_pairs);
  for i = 1 : length(ant_exo_list)
      if ~isempty(r.anticipated_pairs.(ant_exo_list{i}))
          tune_name = r.anticipated_pairs.(ant_exo_list{i});
          if isfield(dtunes,tune_name)
            write_hard_tune(fid,'			',tune_name,ant_exo_list{i},dtunes.(tune_name),1);
          end
      end
  end
  
  % unanticipated hard tunes
  sur_exo_list = fieldnames(r.surprise_pairs);
  for i = 1 : length(sur_exo_list)
      if ~isempty(r.surprise_pairs.(sur_exo_list{i}))
          tune_name = r.surprise_pairs.(sur_exo_list{i});
          if isfield(dtunes,tune_name)
            write_hard_tune(fid,'			',tune_name,sur_exo_list{i},dtunes.(tune_name),0);
          end
      end
  end
  
  % soft tunes
  soft_list = dbnames(dtunes,'nameFilter=','^SHK_.');
  for i = 1 : numel(soft_list)
     % check if anticipated
     if isfield(r.anticipated_pairs,soft_list{i})
         write_soft_tune(fid,'			',soft_list{i},dtunes.(soft_list{i}),1);
     else
         write_soft_tune(fid,'			',soft_list{i},dtunes.(soft_list{i}),0);
     end
  end
  
  % finish
  fprintf(fid, '    </tunes>\n');
  fprintf(fid, '</scenario>\n');
  
  fclose(fid);  
end

function write_hard_tune(fid, indent, tune, shock, data, ant)
  if ant
      ant = 'true';
  else
      ant = 'false';
  end
  fprintf(fid, '%s<tune isAnticipated="%s">\n',indent,ant);
  fprintf(fid, '%s    <variablename>%s</variablename>\n', indent, tune);
  fprintf(fid, '%s    <shocklink>%s</shocklink>\n', indent, shock);
  fprintf(fid, '%s    <values>\n',indent);
  rng = get(data,'range');
  for i = 1 : length(rng)
      fprintf(fid,'%s        <value date="%s">%.13g</value>\n',indent,dat2char(rng(i)),data(rng(i)));
  end
  fprintf(fid, '%s    </values>\n',indent);
  fprintf(fid, '%s</tune>\n',indent);
end

function write_soft_tune(fid, indent, shock, data, ant)
  if ant
      ant = 'true';
  else
      ant = 'false';
  end
  fprintf(fid, '%s<tune isAnticipated="%s">\n',indent,ant);
  fprintf(fid, '%s    <variablename>%s</variablename>\n', indent, shock);  
  fprintf(fid, '%s    <shocklink/>\n',indent);
  fprintf(fid, '%s    <values>\n',indent);
  rng = get(data,'range');
  for i = 1 : length(rng)
      fprintf(fid,'%s        <value date="%s">%.13g</value>\n',indent,dat2char(rng(i)),data(rng(i)));
  end
  fprintf(fid, '%s    </values>\n',indent);
  fprintf(fid, '%s</tune>\n',indent);
end
