classdef pathincr < handle
    
  properties (SetAccess = protected)
    % directory name added to the path
    dir = '';
    % flag whether it should be removed in the destructor
    to_remove = false;
  end
    
  methods
    % constructor: add the given directory to the path
    function self = pathincr(dir)
      self.dir = dir;
      is_on_path = pathincr.is_on_search_path(dir);
      self.to_remove = ~ is_on_path;
      if ~is_on_path
        addpath(dir);
      end
    end
      
    % destructor: remove directory from the path if is to be removed
    function delete(self)
      if self.to_remove
        rmpath(self.dir);
      end
    end
    
  end
    
  methods (Static)
    % return true if the given dir is on the matlab search path
    function r = is_on_search_path(dir)
    % create temporary file in the directory 
      [~, basetmp] = fileparts(tempname);
      tmp = [dir filesep basetmp '.m'];
      fid = fopen(tmp,'w');
      fprintf(fid, ' ');
      fclose(fid);
      % call exist
      if 2 == exist([basetmp '.m'])
        r = true;
      else
        r = false;
      end
      % remove the file
      delete(tmp);
    end
    
  end
  
end
