function rd = az_define_forecast_report(model_switches)

rd = cell(1,0);

%% Tables

% summary table
p = struct();
p.title = 'Summary table';
p.titlefootnote = 'Growth rates and inflations in log per cent';
p.table = {struct('label','Overview',...
	'series',{{'i','d4l_cpi','d4l_y','azn_usd'}},...
  'dd',{{1,1,1,2}}),...
	struct('label','Gaps',...
	'series',{{'l_y_gap','l_z_gap','r_gap','l_qoil_gap'}}),...
  struct('label','Trends and targets',...
	'series',{{'dl_cpi_tar','dl_y_tnd','dl_z_tnd','prem'}}),...
	struct('label','External sector',...
	'series',{{'i_us','oil','rub_usd'}})};
rd{end+1} = p;

%#2
p = struct();
p.title = 'Analytic: demand and supply';
p.titlefootnote = ['Growth rates and inflations in log differences, ' ...
	'interest rates continuosly compounded'];
p.table = {struct('label','IS Curve',...
	'series',{{'l_y_gap','l_z_gap','r_gap','l_y_foreign_gap','shock_l_y_gap'}}),...
	struct('label','Phillips Curve',...
	'series',{{'dl_cpi','e_dl_cpi','dl_cpi_imp','l_z_gap','l_y_gap','l_qfood_gap','shock_dl_cpi'}}),...
	};
rd{end+1} = p;

%#3
p = struct();
p.title = 'Analytic: monetary policy';
p.titlefootnote = ['Growth rates and inflations in log differences, ' ...
	'interest rates continuosly compounded, ' ...
	'levels in 100*log'];
p.table = {struct('label','Taylor Rule',...
	'series',{{'i','i_tnd','d4l_cpi','l_y_gap','shock_i'}}),...
	struct('label','UIP',...
	'series',{{'l_azn_usd','e_l_azn_usd','i','i_us','prem','shock_l_azn_usd'}})};
rd{end+1} = p;

%% Charts
% summary graphs
p = struct();
p.title = 'Summary graphs';
p.series = {'i','azn_usd','d4l_cpi','d4l_y'};
rd{end+1} = p;

p = struct();
p.title = 'Gaps';
p.series = {'l_y_gap', 'l_z_gap', 'l_qoil_gap', 'r_gap'};
rd{end+1} = p;

p = struct();
p.title = 'Trends';
p.series = {'l_z_tnd', 'prem', 'r_tnd', 'dl_cpi_tar'};
rd{end+1} = p;

% p = struct();
% p.title = 'Trends changes';
% p.series = {'dl_z_tnd', 'dl_y_tnd'};
% rd{end+1} = p;

% % Inflations
% p = struct();
% p.title = 'Domestic Inflations';
% p.series = {'dl_cpi','d4l_cpi'};
% rd{end+1} = p;

end
