% compares forecast results to the actual data

%% Housekeeping
close all
clc

%% Load data
load az_actual_data.mat
data = x;

fcast = dbload('az_model/results/az202004_baseline_forecast.csv');

%% Plot
rng = qq(2012,1):qq(2017,4);

figure;
subplot(231);
  plot(rng, exp([data.d4l_cpi fcast.d4l_cpi]/100)*100-100);
  grid;
  title('CPI Inflation (% YoY)');
  legend('Data','Forecast');
subplot(232);
  plot(rng, exp([data.d4l_y fcast.d4l_y]/100)*100-100);
  grid;
  title('GDP Growth (% YoY)');
subplot(233);
  plot(rng, exp([data.l_azn_usd fcast.l_azn_usd]/100));
  grid;
  title('Nominal FX rate (AZN per USD)');
subplot(234);
  plot(rng, exp([data.ip fcast.i]/100)*100-100);
  grid;
  title('Policy rate (% p.a.)');   
subplot(236);
  plot(rng, [data.l_z-data.l_z(qq(2014,1)) ...
            fcast.l_z-fcast.l_z(qq(2014,1))]+100);
  grid;
  title('Real effective exchange rate (100*log)');

    