clear; close all; home

% BY
% list_rounds = {'by201103','by201012','by201010','by20100920'}; % fcast round
% list_vars   = {'byr_usd','i','d4l_cpi'}; % names of variables

% GT
list_rounds = {'gt201102','gt201012_inter','gt201011','gt20100820'}; % fcast round
list_vars   = {'gtq_usd','i','d4l_cpi'}; % names of variables

% MN
% list_rounds = {'mn201101','mn201102'}; % fcast round
% list_vars   = {'mnt_usd','i','d4l_cpi'}; % names of variables

% TJ
% list_rounds = {'tj201104','tj201101','tj201010'}; % fcast round
% list_vars   = {'tjs_usd','ip','d4l_cpi'}; % names of variables

% UZ
% list_rounds = {'uz201103','uz201012'}; % fcast round
% list_vars   = {'uzs_usd_p','ip','d4l_cpi'}; % names of variables

list_log    = {'d4l_cpi'}; % transform from log
list_per    = {qq(2011,1), qq(2011,2)}; % periods of fcast interest
conf_band   = 0.7; % confidence bands

disp('Annual comparison running ...');
ogir=ogiroot();
db_out = dbempty;
for i=1:length(list_rounds)
    if exist([ogir.xopt.opt.wdir,'/rounds/',list_rounds{i}],'dir')==7
        disp(list_rounds{i});
        db = loadstruct([ogir.xopt.opt.wdir,'/rounds/',list_rounds{i},'/sm/results/',list_rounds{i}(1:2),'_confbands.mat']);
        for ii=1:length(db.clev)
            if db.clev(ii)-conf_band ==0
                conf = ii;
                break;
            end
        end
        time_ =  mm(str2num(list_rounds{i}(3:6)),str2num(list_rounds{i}(7:8)));
        for ii=1:length(list_vars)
            lngth_ = length(db.cfBands.(list_vars{ii})(get(db.cfBands.(list_vars{ii}),'first')));
            if i ==1
              for iii = 1:length(list_per)
                db_out.([list_vars{ii},'_',dat2char(list_per{iii}),'_mean']) = tseries(time_, db.cfBands.(list_vars{ii})(list_per{iii},ceil(lngth_/2)));
                db_out.([list_vars{ii},'_',dat2char(list_per{iii}),'_lower',num2str(100*conf_band)]) = tseries(time_, db.cfBands.(list_vars{ii})(list_per{iii},conf));
                db_out.([list_vars{ii},'_',dat2char(list_per{iii}),'_upper',num2str(100*conf_band)]) = tseries(time_, db.cfBands.(list_vars{ii})(list_per{iii},lngth_-conf+1));
              end
            else
              for iii = 1:length(list_per)  
                db_out.([list_vars{ii},'_',dat2char(list_per{iii}),'_mean'])(time_) = db.cfBands.(list_vars{ii})(list_per{iii},ceil(lngth_/2));
                db_out.([list_vars{ii},'_',dat2char(list_per{iii}),'_lower',num2str(100*conf_band)])(time_) = db.cfBands.(list_vars{ii})(list_per{iii},conf);
                db_out.([list_vars{ii},'_',dat2char(list_per{iii}),'_upper',num2str(100*conf_band)])(time_) = db.cfBands.(list_vars{ii})(list_per{iii},lngth_-conf+1);
              end
            end
            db_out.(['tmp',num2str(ii)]) = tseries();
        end
    else
        error([list_rounds{i} ' does not exists.']);
    end
end

list_ = dbobjects(db_out);
for i=1:length(list_)
    if strmatch(list_log,list_{i})
        db_out.(list_{i}) = 100*(exp(db_out.(list_{i})/100)-1);
    end
end

tmp = irisget('dateformat');
irisset('dateformat','YYYYFP');
dbsave(db_out,[list_rounds{1}(1:2),'_annual_comp.csv'],Inf,'class',false);
irisset('dateformat',tmp);
