function x = calculate_log_level_from_overlapping_growths(d)
  
  % x will be unknown 100*log level, will optimize for deviations of
  % actual x growth rates and growth rates in d, the only constraint is
  % that x is zero in the beginning
  dd = d(:);
  rng = get(d, 'range');
  nx = length(rng)+1;
  kk = find(~isnan(dd));
  nra = numel(kk);
  %- optimization: matrices A and a
  A = zeros(nra, nx);
  [ii,jj]=ind2sub(size(dd),kk);
  kkk = sub2ind(size(A),(1:nra)',ii+1);
  A(kkk) = 1;
  kkk = sub2ind(size(A),(1:nra)',ii);
  A(kkk) = -1;
  a = dd(kk);
  %- constraints: matrices B and b
  B = zeros(1, nx);
  B(1,1) = 1;
  b = 0;
  %- calculate and return
  x = constrained_lsq(A, a, B, b);
  x = tseries(rng(1)-1:rng(end),x);
end