% solve problem min ||Ax-b|| constrained by Bx=b
function x = constrained_lsq(A,a,B,b)
  
  nc = size(B,1);
  nx = size(B,2);

  if size(A,2) ~= nx
    error('Wrong number of columns of matrix A');
  end
  if size(A,1) ~= size(a,1)
    error('Number of rows of A, and a must be the same');
  end
  if size(B,1) ~= size(b,1)
    error('Number of rows of B, and b must be the same');
  end
  
  % solve the constraints
  [R,Q] = rq(B);
  R2=R(:,nx-nc+1:nx);
  y2 = R2\b;
  
  % solve y1 from min||Ax-b||
  [Z,P] = qr(A*Q');
  P11 = P(1:nx-nc,1:nx-nc);
  P12 = P(1:nx-nc,nx-nc+1:end);
  zta = Z'*a;
  zta1 = zta(1:nx-nc);
  y1 = P11\(zta1-P12*y2);
  
  % return x
  x = Q'*[y1;y2];
end
  