% converts difference b from a both with sd significant digits and dd
% decimal digits of type 'type' to the string representation; type can be
% either 'subtract', 'logdiff', or 'pp'. 'pp' and 'subtract' are
% mathematically equivalent

function str = diff2gstr(a, b, sd, dd, type)

  if abs(a-b)<1e-10 % used tolerance, originally: a == b
    str = '=';
    return;
  end
  
  % calculate significant digits for a difference
  sdd = max(0,sd-(ceil(log(abs(a))/log(10))-ceil(log(abs(a-b))/log(10))));
  
  % make the difference
  g = a-b;
  if strcmp('logdiff',type)
    g = 100*log(a/b);
  end

  % set left and right brackets
  lb = '';
  rb = '';
  if strcmp('pp',type)
    lb = '[';
    rb = ']';
  elseif strcmp('logdiff', type)
    lb = '(';
    rb = ')';
  end
  
  % return the string
  str = [lb num2gstr(g, sdd, dd) rb];
  