% executes commands parallely
% Parameters description:
%   commands
%     cell array of strings with commands (including path and arguments)
%   varargin options:
%     'cores'
%         number of running threads, if not defined use as many as number of
%         cores
%     'labels'
%         label of each running command
%

% assumes that "javaaddpath <ogresearch>/GeneralCodes/java/paralexe/dest/paralexec.jar"
% has been run in Matlab

function [rvals, stdouts, labels] = execute_paral_commands(commands, varargin)
  optnames = {varargin{1:2:end}};
  optvals = {varargin{2:2:end}};
  opt = cell2struct(optvals, optnames, 2);
  if ~isfield(opt, 'labels')
    opt.labels={};
  end

  import paralexec.ParalExec ;
  if length(commands) > length(opt.labels)
    disp('less(or none) labels given then commands, using order value instead');
    for i = 1:length(commands)
      opt.labels{i}=['label_' num2str(i)];
    end
  end
  
  if isfield(opt,'cores')
    pe = ParalExec(commands, opt.labels, opt.cores);
  else
    pe = ParalExec(commands, opt.labels);
  end
  rvals = pe.getExitVals();
  stdouts = cell(pe.getOutputs());
  labels = opt.labels;
end
