function out = fill_nan(ts,rng)
% out = fill_nan(ts,rng)
% Fills missing observations in by the value of the last observation.
% If there is no preceeding observation, NaN is filled by value of the fist following observation.
% If 'rng' is not specify - return timeseries over entire range of ts
% If 'rng' is specified, then return values over 'rng'

 tsRng = get(ts,'range');
 switch nargin
  case 1
    out = ts; 
    IsNaN = tsRng(isnan(out(tsRng)));
    for k=IsNaN
      out(k) = out(k-1);
    end
    
  case 2
    % check whether some value is observed before beginning of rng
    if tsRng(1)<rng(1)
      % if any value is observed before beginning of rng, take the last
      tmp_ = tsRng(~isnan(ts(tsRng(1):rng(1))));
      sValue = ts(tmp_(end));
    else
      % otherwise take the first obsered value
      sValue = ts(tsRng(1));
    end
    out = ts(rng);
    IsNaN = 1:numel(out);
    out(1) = sValue;
    IsNaN = IsNaN(isnan(out));
    for k=IsNaN
      out(k) = out(k-1);
    end
    out = tseries(rng,out);
    
  otherwise
  error('Too many input arguments');
 end

end