function [Y_tnd,Y_gap,Y, Y_shock, data_out]=hpf_adjusted(data,varargin)
frequency=get(data.obs_y,'freq');
c1_l_y_gap=0;
ss_dl_y_tnd=0;
c1_dl_y_tnd=1;
lambda=1600;%100*frequency^2;
p.std_shock_dl_y_tnd=1;
p.std_shock_l_yearly=1;

%% read optional arguments
for iter=1:2:length(varargin)
    switch lower(varargin{iter})
        case 'lambda'
            lambda=varargin{iter+1};
        case 'rho_gap'
            c1_l_y_gap=varargin{iter+1};
        case 'rho_trend'
            c1_dl_y_tnd=varargin{iter+1};
        case 'ss_trend'
            ss_dl_y_tnd=varargin{iter+1};
        case 'range'
            hpRng=varargin{iter+1};
        otherwise
            error('Unknown optional argument: %s',varargin{iter});
    end
end

%% set parameters structure
p.c1_l_y_gap=c1_l_y_gap;
p.std_shock_l_y_gap=sqrt(lambda)/4;% divided by 4 because the growth rate (dl_y_tnd) in hpf_adjusted.mod is at annualized rate
p.c1_dl_y_tnd=c1_dl_y_tnd;
p.ss_dl_y_tnd=ss_dl_y_tnd;


if frequency==4,
    data.obs_y=data.obs_y;
    if isfield(data,'obs_y_yearly');
        rng=get(data.obs_y_yearly,'range');
        start=dat2dec(rng(1));
        finish=dat2dec(rng(end));
        data.obs_y_yearly=tseries(qq(start,4):4:qq(finish,4),data.obs_y_yearly(:));
    else
        data.obs_y_yearly=tseries();
    end
elseif frequency==1
    rng=get(data.obs_y,'range');
    start=dat2dec(rng(1));
    finish=dat2dec(rng(end));
    data.obs_y_yearly=tseries(qq(start,4):4:qq(finish,4),data.obs_y(:));
    data = rmfield(data,'obs_y');
else
    error('TS should be of Q or Y frequency!')
end


if ~exist('hpRng','var')
    pom=dbobjects(data);
    hpRng=get(data.(pom{1}),'range');
end

%% model and database
m = model('hpf_adjusted.mod','assign',p,'linear',true);
m = solve(m);

%% filtering
[m,smooth,se2,delta,pe] = filter(m,data,hpRng);
s=smooth.mean;

%% reporting
Y_tnd = s.l_y_tnd;
Y_gap = s.l_y_gap;
Y = s.l_y;
Y_shock = s.shock_l_yearly;
data_out = s;
end