
!variables:transition
'Output (log)'                              l_y
'Potential Output (log)'                    l_y_tnd
'Output Gap'                                l_y_gap
'Potential Output Growth'                   dl_y_tnd
'Output Yearly'                             y_yearly
'Output Yearly (100*log)'                   l_y_yearly
'Output'                                    y
'Potential Output'                          y_tnd


!variables:measurement
'Measurement Variables'
    obs_y_yearly
    obs_y
    
!variables:log
'Log-Linear Variables'
    y_yearly
    y
    y_tnd
    obs_y_yearly
    obs_y

!shocks:transition
'Transition Shocks'
    shock_l_y_gap
    shock_dl_y_tnd
    shock_l_yearly

!parameters
'Transition Parameters'
    c1_l_y_gap 
    c1_dl_y_tnd
    ss_dl_y_tnd

!equations:transition
'Gap'
l_y_gap = c1_l_y_gap*l_y_gap{-1} + shock_l_y_gap;


'Identities'
l_y      = l_y_tnd + l_y_gap;
dl_y_tnd = 4*(l_y_tnd - l_y_tnd{-1});


'Trends'
dl_y_tnd = c1_dl_y_tnd*dl_y_tnd{-1} + (1-c1_dl_y_tnd)*ss_dl_y_tnd + shock_dl_y_tnd;


'Output'
l_y_yearly = 100*log(4)+(l_y + l_y{-1} + l_y{-2} + l_y{-3})/4 + shock_l_yearly;


'Transformations'
100*log(y_yearly)   = l_y_yearly;
100*log(y)          = l_y;
100*log(y_tnd)      = l_y_tnd;


!equations:measurement
'Measurement'
obs_y               = y;
obs_y_yearly        = y_yearly;
