function xout = nansum_(xin,dim)
if nargin==1
    dim=1;
end
if dim > ndims(xin)
   error('dim greater than number of dimensions')
end

isTser = istseries(xin);
if isTser
  rng=get(xin,'range');
  xin=xin(:);
end

x = xin;
index = ~isnan(x);
x(~index) = 0;
x = sum(x,dim);

% sum of nans only results in nan

tmp = sum(isnan(xin),dim);
tmp(tmp~=size(xin,dim))=0;
tmp(tmp==size(xin,dim))=nan;
xout = x + tmp;


if isTser && dim~=1
  xout=tseries(rng,x);
end
end