function res=norm_cdf(x,mu,sigma)
%   function res=norm_cdf(x,mu,sigma)
%   returns the cdf of the normal distribution with  mean MU and 
%   standard deviation SIGMA, evaluated at the values in X.

%   Default values for MU and SIGMA are 0 and 1, respectively.
%%
if nargin<1
    error('Input argument X is undefined.');
end
if nargin < 2
    mu = 0;
end
if nargin < 3
    sigma = 1;
end
% Return NaN for out of range parameters.
if any(sigma<=0)
  error('sigma should be positive');
end

try
  res = 0.5*(1+erf((x-mu)./(sigma*sqrt(2))));
catch
    error('Non-scalar arguments must match in size.');
end

