function cf=norm_confbands(clev,forecastStd)
%function calculates confidence intervals specified in clev for normal
%distributions with zero mean and std. deviations stored in vector
%forecastStd.
%
%Inputs: clev ....................... confidence levels for example 
%                                     [0.90 0.70 0.50 0.30 0.1]. In this 
%                                     case cf will have 11 timeseries for
%                                     each field (variable) in forecastStd
%        forecastStd ................ vector of std. deviations of normal
%                                     distributions

np=length(forecastStd);

% precalculate the confidence intervals for normal(0,1)
mult = zeros(1,length(clev));
for iter=1:length(clev)
  mult(iter) = -sqrt(2)*erfcinv((1-clev(iter)));% norminv(p)=-sqrt(2)*erfcinv(2*p)
end


% create the confbands
  cf = zeros(np, 2*length(clev)+1);
  for iter=1:length(clev)
    cf(:,iter) = +mult(iter)*forecastStd;
    cf(:,end-iter+1) = -mult(iter)*forecastStd;
  end
end