% converts a double to a string with a given number of significant digits
% and maximum number of decimal digits
function str = num2gstr(a, sd, dd)
  
  if a == 0
    str = '0';
    return;
  end
  
  m = ceil(log(abs(a))/log(10));
  sd = min(sd, m+dd);
  g = sign(a)*round(abs(a)*10^(sd-m))/10^(sd-m);

  % if g is zero or significant digits are zero, exit with zero
  if a == 0 || g == 0 %|| sd == 0
    str = '0';
    return;
  end
  
  f='%f';
  % make a format and accommodate g
  if m < sd & m > -2
    f = sprintf('%%%d.%df',max(m-1)+1,sd-m);
  elseif m == sd | m == sd+1
    f = '%d';
  elseif m > sd+1
    f = sprintf('%%1.%dfe%d',max(0,sd-1),m-1);
    g = g*10^(-m+1);
  elseif m <= -2
    f = sprintf('%%1.%dfe%d',max(0,sd-1),m-1);
    g = g*10^(-m+1);
  end
  % format and return
  str = sprintf(f, g);
end
