% strips latex preable and also \end{document} from the file fin and
% saves it to the file name fout.

function strip_latex_preamble(fin, fout)
  
  % create perl script
  fid = fopen('tobedeleted.pl','w');
  fprintf(fid,'my $fin = $ARGV[0];\n');
  fprintf(fid,'my $fout = $ARGV[1];\n');
  fprintf(fid,'open(FDIN,"<$fin") or die "Cannot open $fin for reading: $!\\n";\n');
  fprintf(fid,'open(FDOUT,">$fout") or die "Cannot open $fout for writing: $!\\n";\n');
  fprintf(fid,'my $preamble=1;\n');
  fprintf(fid,'while (<FDIN>) {\n');
  fprintf(fid,'    if (/begin\\{document\\}/) {\n');
  fprintf(fid,'	       $preamble = 0;\n');
  fprintf(fid,'	       next;\n');
  fprintf(fid,'    \n}');
  fprintf(fid,'    next if (/end\\{document\\}/);\n');
  fprintf(fid,'    print FDOUT if ($preamble == 0);\n');
  fprintf(fid,'}\n');
  fprintf(fid,'close(FDOUT);\n');
  fprintf(fid,'close(FDIN);\n');
  fclose(fid);

  % run the perl script
  perl('tobedeleted.pl',fin,fout);
  
  % cleanup
  delete('tobedeleted.pl');
  delete(fin);
  
end